<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Array Instructions</TITLE>
<link href="suif1_37.html" rel=Next>
<link href="suif1_35.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_35.html">previous</A>, <A HREF="suif1_37.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC36" HREF="suif1_toc.html#TOC36">Array Instructions</A></H2>
<P>
<A NAME="IDX218"></A>
<A NAME="IDX219"></A>

</P>
<P>
<A NAME="IDX220"></A>
Because many SUIF passes focus on analyzing and optimizing Fortran code,
a high-level representation of array references is crucial.  SUIF
provides <CODE>array</CODE> instructions which retain all of the high-level
information in combination with other fields needed to generate code for
the address computations.  The <CODE>in_array</CODE> class is used to hold
these array instructions.

</P>
<P>
<A NAME="IDX221"></A>
<A NAME="IDX222"></A>
<A NAME="IDX223"></A>
<A NAME="IDX224"></A>
<A NAME="IDX225"></A>
<A NAME="IDX226"></A>
Array instructions include a number of fields.  First, a pointer to the
base of the array is specified in an operand field that can be accessed
with the <CODE>base_op</CODE> and <CODE>set_base_op</CODE> methods.  If the array
elements are structures, a constant offset within the selected element
may be included.  This optional integer offset can be accessed using the
<CODE>offset</CODE> and <CODE>set_offset</CODE> methods.  The element size is needed
to generate low-level code for the array address calculation.  The
<CODE>elem_size</CODE> method returns the element size in bits.  The
<CODE>set_elem_size</CODE> method may be used to change the element size.

</P>
<P>
<A NAME="IDX227"></A>
<A NAME="IDX228"></A>
Because Fortran arrays do not always begin with index zero, an optional
operand, which is referenced using the <CODE>offset_op</CODE> and
<CODE>set_offset_op</CODE> methods, is provided to specify an offset.  Since
there is a single offset operand, the offsets for all of the dimensions
must be combined into a single value.  The arrays are stored in
row-major form, so the offset for the first dimension is multiplied by
the size of the remaining dimensions, etc.  If the offset operand is
provided, it must have an integer type.

</P>
<P>
<A NAME="IDX229"></A>
<A NAME="IDX230"></A>
<A NAME="IDX231"></A>
<A NAME="IDX232"></A>
<A NAME="IDX233"></A>
<A NAME="IDX234"></A>
Array instructions can treat arrays of arrays as multidimensional
arrays, even though the type system does not support that directly.
Each array instruction includes a field to specify the number of
dimensions in the array.  This field may be accessed with the
<CODE>dims</CODE> and <CODE>set_dims</CODE> methods.  The indexes for the array
reference are stored in an array of source operands, one for each
dimension.  These index operands can be accessed using the <CODE>index</CODE>
and <CODE>set_index</CODE> methods.  The dimensions are numbered beginning
with zero.  Similarly, the number of elements in each dimension are
stored in another array of source operands, which can be accessed with
the <CODE>bound</CODE> and <CODE>set_bound</CODE> methods.

</P>
<P>
<A NAME="IDX235"></A>
The result type of an array instruction must be a pointer.  However, it
need not be a pointer to the element type.  If the elements are
structures, the result type may be a pointer to one of the structure
fields.  SUIF does not actually require that the result type match
anything within the array element type, although that is highly
recommended.  The <CODE>elem_type</CODE> method can be used to determine the
actual type of the element being addressed.

</P>
<P>
The types of the array instruction operands must follow some
conventions.  The index and bound operands must all have integer types.
The base operand must be a pointer to an array.  If the array
instruction has multiple dimensions, the base must point to a nested
array (an array of arrays of arrays...) with the same depth as the
number of dimensions.  For each dimension, if the bound operand is a
constant, it must match the number of elements specified in the
corresponding array type.  (If the lower and upper bounds in the array
type are not both constant, then the bound operand may have any value.)
The bound operand for the first dimension is optional and may be null.
Finally, the element size must match the size of the elements in the
array type.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_35.html">previous</A>, <A HREF="suif1_37.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
